<?php

/*
	[DISCUZ!] admin/database.php - dump, import, optimize, maintance database
	This is NOT a freeware, use is subject to license terms

	Version: 2.1.0
	Author: Crossday (info@discuz.net)
	Copyright: Crossday Studio (www.crossday.com)
	Last Modified: 2002/12/25 10:00
*/


if(!defined("IN_DISCUZ")) {
        exit("Access Denied");
}

include $discuz_root.'./include/attachment.php';

if($action == "export" && $exportsubmit && $type) {
	$db->query("SET SQL_QUOTE_SHOW_CREATE = 0");
	$sqldump = "";
	$time = gmdate("$dateformat $timeformat", $timestamp + $timeoffset * 3600);
	if($type == "all") {
		$tables = array('announcements', 'attachments', 'banned', 'buddys', 'favorites', 'forumlinks', 'forums',
				'karmalog', 'members', 'posts', 'searchindex', 'sessions', 'settings', 'smilies',
				'stats', 'styles', 'stylevars', 'subscriptions', 'templates', 'threads', 'pm', 'usergroups',
				'words');
	} elseif($type == "standard") {
		$tables = array('announcements', 'attachments', 'banned', 'buddys', 'forumlinks', 'forums', 'karmalog',
				'members', 'posts', 'settings', 'smilies', 'stats', 'styles', 'stylevars',
				'templates', 'threads', 'usergroups', 'words');
	} elseif($type == "majority") {
		$tables = array('attachments', 'forumlinks', 'forums', 'members', 'posts', 'settings', 'smilies', 'stats',
				'styles', 'stylevars', 'templates', 'threads', 'usergroups');
	} elseif($type == "mini") {
		$tables = array('announcements', 'banned', 'forumlinks', 'forums', 'members', 'settings', 'smilies', 'stats',
				'styles', 'stylevars', 'templates', 'usergroups', 'words');
	}

	$sqldump = '';
	if($multivol) {
		if($saveto == 'server') {
			$volume = intval($volume) + 1;
			$tableid = $tableid ? $tableid - 1 : 0;
			$startfrom = intval($startfrom);
			for($i = $tableid; $i < count($tables) && strlen($sqldump) < $sizelimit * 1000; $i++) {
				$sqldump .= sqldumptable($tablepre.$tables[$i], $startfrom, strlen($sqldump));
				$startfrom = 0;
			}
			$tableid = $i;
		} else {
			cpheader();
			cpmsg("ֻбݵʹ÷־ݹܡ");
		}
	} else {
		foreach($tables as $table) {
			$sqldump .= sqldumptable($tablepre.$table);
		}
	}

	$dumpfile = substr($filename, 0, strrpos($filename, "."))."-%s".strrchr($filename, ".");
	if(trim($sqldump)) {
		$dumpversion = strip_tags($version);
		$sqldump = "# Identify: ".base64_encode("$timestamp,$dumpversion,$type,$multivol,$volume")."\n".
			"#\n".
			"# Discuz! Data Dump".($multivol ? " Volume $volume" : NULL)."\n".
			"# Version: Discuz! $dumpversion\n".
			"# Time: $time\n".
			"# Type: $type\n".
			"# Tablepre: $tablepre\n".
			"#\n".
			"# Discuz! Community: http://www.Discuz.net\n".
			"# Please visit our website for newest infomation about Discuz!\n".
			"# --------------------------------------------------------\n\n\n".
			$sqldump;

		if($saveto == "local") {
			ob_end_clean();
			header('Content-Encoding: none');
			header('Content-Type: '.(strpos($HTTP_SERVER_VARS['HTTP_USER_AGENT'], 'MSIE') ? 'application/octetstream' : 'application/octet-stream'));
			header('Content-Disposition: '.(strpos($HTTP_SERVER_VARS['HTTP_USER_AGENT'], 'MSIE') ? 'inline; ' : 'attachment; ').'filename="dz_'.date('ymd').'.sql"');
			header('Content-Length: '.strlen($sqldump));  //fix: ļȼ߼
			header('Pragma: no-cache');
			header('Expires: 0');
			echo $sqldump;
			discuz_exit();
		} elseif($saveto == "server") {
			cpheader();
			if($filename != "") {
				@$fp = fopen(($multivol ? sprintf($dumpfile, $volume) : $filename), "w");
				@flock($fp, 3);
				if(@!fwrite($fp, $sqldump)) {
					@fclose($fp);
					cpmsg("ļ޷浽Ŀ¼ԡ");
				} elseif($multivol) {
					cpmsg("־ݣļ #$volume ɹԶ", "admincp.php?action=export&type=$type&saveto=server&filename=$filename&multivol=1&sizelimit=$sizelimit&volume=$volume&tableid=$tableid&startfrom=$startrow&exportsubmit=yes");
				} else {
					cpmsg("ݳɹ <a href=\"$filename\">$filename</a> С");
				}
			} else {
				cpmsg("û뱸ļ뷵޸ġ");
			}
		}
	} else {
		if($multivol) {
			$volume--;
			$filelist = "<ul>";
			for($i = 1; $i <= $volume; $i++) {
				$filename = sprintf($dumpfile, $i);
				$filelist .= "<li><a href=\"$filename\">$filename\n";
			}
			cpheader();
			cpmsg("ϲȫ $volume ļɹɡ\n<br>$filelist");
		} else {
			cpheader();
			cpmsg("ݳݱûݡ");
		}
	}
}

cpheader();

if($action == "export") {
	if(!$exportsubmit) {

?>
<table cellspacing="0" cellpadding="0" border="0" width="90%" align="center">
<tr><td bgcolor="<?=BORDERCOLOR?>">
<table border="0" cellspacing="<?=BORDERWIDTH?>" cellpadding="<?=TABLESPACE?>" width="100%">
<tr class="header"><td>رʾ</td></tr>
<tr bgcolor="<?=ALTBG1?>"><td>
<br><ul><li>ݱݹܸѡ񱸷ȫ̳Ӻݣļáݻָܻ phpMyAdmin 롣</ul>
<ul><li>ıֹֻת attachments Ŀ¼ļɣDiscuz! ṩݡ</ul>
<ul><li>ǿҽ飺ݵʹ .sql Ϊչ⽫պάܴ󷽱㡣</ul>
</td></tr></table></td></tr></table>

<br><br><form name="backup" method="post" action="admincp.php?action=export">
<table cellspacing="0" cellpadding="0" border="0" width="90%" align="center">
<tr><td bgcolor="<?=BORDERCOLOR?>">
<table border="0" cellspacing="<?=BORDERWIDTH?>" cellpadding="<?=TABLESPACE?>" width="100%">
<tr class="header"><td colspan="2">ݱݷʽ</td></tr>
<tr>
<td bgcolor="<?=ALTBG1?>" width="40%"><input type="radio" value="all" name="type"> ȫ</td>
<td bgcolor="<?=ALTBG2?>" width="60%">̳ȫݱ(ģ͸ļ)</td></tr>

<tr>
<td bgcolor="<?=ALTBG1?>"><input type="radio" value="standard" checked name="type"> ׼(Ƽ)</td>
<td bgcolor="<?=ALTBG2?>">õȫݱ</td></tr>

<tr>
<td bgcolor="<?=ALTBG1?>"><input type="radio" value="majority" name="type"> 򱸷</td>
<td bgcolor="<?=ALTBG2?>">ûü</td></tr>

<tr>
<td bgcolor="<?=ALTBG1?>"><input type="radio" value="mini" name="type" > С</td>
<td bgcolor="<?=ALTBG2?>">ûüϵͳ</td></tr>

<tr bgcolor="<?=ALTBG2?>" class="header"><td colspan="2">ѡĿλ</td></tr>

<tr bgcolor="<?=ALTBG2?>">
<td colspan="2"><input type="radio" value="local" name="saveto" onclick="this.form.filename.disabled=this.checked;if(this.form.multivol.checked) {alert('ע⣺\n\nݵ޷ʹ÷־ݹܡ');this.form.multivol.checked=false;this.form.sizelimit.disabled=true;}"> ݵ</td></tr>
<tr bgcolor="<?=ALTBG2?>"><td><input type="radio" value="server" checked name="saveto" onclick="this.form.filename.disabled=!this.checked"> ݵ</td>
<td><input type="text" size="40" name="filename" value="./forumdata/dz_<?=date('md').'_'.random(5)?>.sql" onclick="alert('ע⣺\n\nļڷĿɼĿ¼£    \nصõЩļǲȫġ    \nʹļͬʱʱɾļ');"></td>
</tr>


<tr class="header"><td colspan="2">ʹ÷־</td></tr>
<tr bgcolor="<?=ALTBG2?>">
<td><input type="checkbox" name="multivol" value="1" onclick="this.form.sizelimit.disabled=!this.checked;if(this.checked && this.form.saveto[1].checked!=true) {alert('ע⣺\n\nֻѡ񱸷ݵʹ÷־ݹܡ');this.form.saveto[1].checked=true;this.form.filename.disabled=false;}"> ļ(KB)</td>
<td><input type="text" size="40" name="sizelimit" value="1024" disabled></td>
</tr></table></td></tr></table><br><center>
<input type="submit" name="exportsubmit" value=""></center></form>
<?

	}

} elseif($action == 'import') {

	 if(!$importsubmit && !$deletesubmit) {
	 	$exportlog = array();
	 	if(is_dir($discuz_root.'./forumdata')) {
	 		$dir = dir($discuz_root.'./forumdata');
			while($entry = $dir->read()) {
				$entry = "./forumdata/$entry";
				if (is_file($entry) && strtolower(strrchr($entry, ".")) == ".sql") {
					$filesize = filesize($entry);
					$fp = fopen($entry, "r");
					$identify = explode(",", base64_decode(preg_replace("/^# Identify:\s*(\w+).*/s", "\\1", fgets($fp, 256))));
					fclose ($fp);
 
					$exportlog[$identify[0]] = array(	"version" => $identify[1],
										"type" => $identify[2],
										"multivol" => $identify[3],
										"volume" => $identify[4],
										"filename" => $entry,
										"size" => $filesize);
				}
			}
			$dir->close();
		} else {
			cpmsg("Ŀ¼ڻ޷ʣ ./forumdata/ Ŀ¼");
		}
		krsort($exportlog);
		reset($exportlog);

		$exportinfo = "";
		foreach($exportlog as $dateline => $info) {
			$info[dateline] = is_int($dateline) ? gmdate("$dateformat $timeformat", $dateline + $timeoffset * 3600) : "δ֪";
			switch($info[type]) {
				case all: $info[type] = "ȫ"; break;
				case standard: $info[type] = "׼"; break;
				case majority: $info[type] = ""; break;
				case mini: $info[type] = "С"; break;
			}
			$info[size] = sizecount($info[size]);
			$info[multivol] = $info[multivol] ? "" : "";
			$info[volume] = $info[multivol] ? $info[volume] : "";
			$exportinfo .= "<tr align=\"center\"><td bgcolor=\"".ALTBG1."\"><input type=\"checkbox\" name=\"delete[]\" value=\"$info[filename]\"></td>\n".
				"<td bgcolor=\"".ALTBG2."\"><a href=\"$info[filename]\">".substr(strrchr($info[filename], "/"), 1)."</a></td>\n".
				"<td bgcolor=\"".ALTBG1."\">$info[version]</td>\n".
				"<td bgcolor=\"".ALTBG2."\">$info[dateline]</td>\n".
				"<td bgcolor=\"".ALTBG1."\">$info[type]</td>\n".
				"<td bgcolor=\"".ALTBG2."\">$info[size]</td>\n".
				"<td bgcolor=\"".ALTBG1."\">$info[multivol]</td>\n".
				"<td bgcolor=\"".ALTBG2."\">$info[volume]</td>\n".
				"<td bgcolor=\"".ALTBG1."\"><a href=\"admincp.php?action=import&from=server&datafile_server=$info[filename]&importsubmit=yes\"".
				($info['version'] != strip_tags($version) ? " onclick=\"return confirm('͵ǰ Discuz! 汾һµݼпܲ޷Ĺϣȷ');\"" : "").">[]</a></td>\n";
		}

?>
<table cellspacing="0" cellpadding="0" border="0" width="90%" align="center">
<tr><td bgcolor="<?=BORDERCOLOR?>">
<table border="0" cellspacing="<?=BORDERWIDTH?>" cellpadding="<?=TABLESPACE?>" width="100%">
<tr class="header"><td>رʾ</td></tr>
<tr bgcolor="<?=ALTBG1?>"><td>
<br><ul><li>ڻָݵͬʱȫԭݣȷǷҪָʧ</ul>
<ul><li>ݻָָֻܻɵǰ汾 Discuz! ļʽ޷ʶ</ul>
<ul><li>ӱػָҪ֧ļϴ֤ݳߴСϴޣֻʹôӷָ</ul>
<ul><li>ʹ˷־ݣֹֻļ 1ļϵͳԶ롣</ul>
</td></tr></table></td></tr></table>

<br><form name="restore" method="post" action="admincp.php?action=import" enctype="multipart/form-data">
<table cellspacing="0" cellpadding="0" border="0" width="90%" align="center">
<tr><td bgcolor="<?=BORDERCOLOR?>">
<table border="0" cellspacing="<?=BORDERWIDTH?>" cellpadding="<?=TABLESPACE?>" width="100%">
<tr class="header">
<td colspan="2">ݻָ</td>
</tr>

<tr>
<td bgcolor="<?=ALTBG1?>" width="40%"><input type="radio" name="from" value="server" checked onclick="this.form.datafile_server.disabled=!this.checked;this.form.datafile.disabled=this.checked">ӷ(дļ URL)</td>
<td bgcolor="<?=ALTBG2?>" width="60%"><input type="text" size="40" name="datafile_server" value="./forumdata/"></td></tr>

<tr>
<td bgcolor="<?=ALTBG1?>" width="40%"><input type="radio" name="from" value="local" onclick="this.form.datafile_server.disabled=this.checked;this.form.datafile.disabled=!this.checked">ӱļ</td>
<td bgcolor="<?=ALTBG2?>" width="60%"><input type="file" size="29" name="datafile" disabled></td></tr>

</table></td></tr></table><br><center>
<input type="submit" name="importsubmit" value="ָ"></center>
</form>

<br><form method="post" action="admincp.php?action=import">
<table cellspacing="0" cellpadding="0" border="0" width="90%" align="center">
<tr><td bgcolor="<?=BORDERCOLOR?>">
<table border="0" cellspacing="<?=BORDERWIDTH?>" cellpadding="<?=TABLESPACE?>" width="100%" class="smalltxt">
<tr class="header"><td colspan="9">ݱݼ¼</td></tr>
<tr align="center" class="header"><td width="45"><input type="checkbox" name="chkall" class="header" onclick="checkall(this.form)">ɾ?</td>
<td>ļ</td><td>汾</td>
<td>ʱ</td><td></td>
<td>ߴ</td><td></td>
<td></td><td></td></tr>
<?=$exportinfo?>
</table></td></tr></table><br><center>
<input type="submit" name="deletesubmit" value="ɾѡ"></center></form>
<?

	 } elseif($importsubmit) {

		$readerror = 0;
		if($from == "server") {
			$datafile = $datafile_server;
			$datafile_size = @filesize($datafile_server);
		}
		@$fp = fopen($datafile, "r");
		if($datafile_size) {
			@flock($fp, 3);
			$sqldump = @fread($fp, $datafile_size);
		} else {
			$sqldump = @fread($fp, 99999999);
		}
		@fclose($fp);
		if(!$sqldump) {
			if($autoimport) {
				updatecache();
				cpmsg("־ݳɹ̳ݿ⡣");
			} else {
				cpmsg("ļڣܷϴļߴ糬ơ");
			}
		} elseif(!strpos($sqldump, "Discuz! Data Dump")) {
			cpmsg("ļ Discuz! ʽ޷롣");
		} else {
			$identify = explode(',', base64_decode(preg_replace("/^# Identify:\s*(\w+).*/s", "\\1", substr($sqldump,0, 256))));
			$dumpinfo = array('multivol' => $identify[3], 'volume' => intval($identify[4]));

			$sqlquery = splitsql($sqldump);
			unset($sqldump);
			foreach($sqlquery as $sql) {
				if(trim($sql) != '') {
					$db->query($sql);
				}
			}

			if($dumpinfo['multivol']) {
				$datafile_next = str_replace("-$dumpinfo[volume].sql", '-'.($dumpinfo['volume'] + 1).'.sql', $datafile_server);
				if($dumpinfo['volume'] == 1) {
					cpmsg('־ݳɹݿ⣬ҪԶ뱾ĵı',
						"admincp.php?action=import&from=server&datafile_server=$datafile_next&autoimport=yes&importsubmit=yes",
						'form');
				} elseif($autoimport) {
					cpmsg("ļ #$dumpinfo[volume] ɹ룬Զ", "admincp.php?action=import&from=server&datafile_server=$datafile_next&autoimport=yes&importsubmit=yes");
				} else {
					updatecache();
					cpmsg("ݳɹ̳ݿ⡣");
				}
			} else {
				updatecache();
				cpmsg("ݳɹ̳ݿ⡣");
			}
		}
	} elseif($deletesubmit) {

		if(is_array($delete)) {
			foreach($delete as $filename) {
				@unlink($filename);
			}
			cpmsg("ָļɹɾ");
		} else {
			cpmsg("ûѡҪɾıļ뷵ء");
		}

	}

} elseif($action == "runquery") {

	if(!$sqlsubmit) {

?>
<br><br><form method="post" action="admincp.php?action=runquery">
<table cellspacing="0" cellpadding="0" border="0" width="550" align="center">
<tr><td bgcolor="<?=BORDERCOLOR?>">
<table border="0" cellspacing="<?=BORDERWIDTH?>" cellpadding="<?=TABLESPACE?>" width="100%">
<tr class="header"><td colspan=2>Discuz! ݿ</td></tr>
<tr bgcolor="<?=ALTBG1?>" align="center">
<td valign="top">뽫ݿճ棺<br><textarea cols="85" rows="10" name="queries"></textarea><br>
<br><center>ע⣺Ϊȷɹ벻Ҫ޸ SQL κβ֡<br><br>
<input type="submit" name="sqlsubmit" value="ݿ"></center>
</td>
</tr>
</table>
</td></tr></table>
</form></td></tr>
<?

	} else {

		$sqlquery = splitsql(str_replace(" cdb_", " $tablepre", $queries));
		foreach($sqlquery as $sql) {
			if(trim($sql) != "") {
				$db->query(stripslashes($sql), 1);
				$sqlerror = $db->error();
				if($sqlerror) {
					break;
				}
			}
		}

		cpmsg($sqlerror ? "MySQL ʾ$sqlerror" : "Discuz! ݽṹɹ");
	}	

} elseif($action == "optimize") {

	$query = $db->query("SELECT VERSION()");
	$dbversion = $db->result($query, 0);
	if($dbversion < '3.23') {
		cpmsg("MySQL 汾 3.23֧Żܡ");
	} else {
?>
<table cellspacing="0" cellpadding="0" border="0" width="90%" align="center">
<tr><td bgcolor="<?=BORDERCOLOR?>">
<table border="0" cellspacing="<?=BORDERWIDTH?>" cellpadding="<?=TABLESPACE?>" width="100%">
<tr class="header"><td>رʾ</td></tr>
<tr bgcolor="<?=ALTBG1?>"><td>
<br><ul><li>ݱŻĹͬƼŻݿԼƬõĴȡͼܡ</ul>
<ul><li> MySQL 3.23 ϰ汾֧֣ǰ MySQL 汾<?=$dbversion?></ul>
</td></tr></table></td></tr></table>

<br><br><form name="optimize" method="post" action="admincp.php?action=optimize">
<table cellspacing="0" cellpadding="0" border="0" width="90%" align="center">
<tr><td bgcolor="<?=BORDERCOLOR?>">
<table border="0" cellspacing="<?=BORDERWIDTH?>" cellpadding="<?=TABLESPACE?>" width="100%">
<tr align="center" class="header">
<td>Ż</td><td>ݱ</td><td></td><td>¼</td>
<td></td><td></td><td>Ƭ</td></tr>
<?
		$optimizetable = "";
		$totalsize = 0;
		if(!$optimizesubmit) {
			$query = $db->query("SHOW TABLE STATUS LIKE '$tablepre%'");
			while($table = $db->fetch_array($query)) {
				echo "<tr>\n".
					"<td bgcolor=\"".ALTBG1."\" align=\"center\"><input type=\"checkbox\" name=\"$table[Name]\" value=\"1\" checked></td>\n".
					"<td td onClick=\"document.optimize.$table[Name].checked = !document.optimize.$table[Name].checked;\" style=\"cursor: hand\" onmouseover=\"this.style.backgroundColor='".ALTBG1."';\" onmouseout=\"this.style.backgroundColor='".ALTBG2."';\" bgcolor=\"".ALTBG2."\" align=\"center\">$table[Name]</td>\n".
					"<td bgcolor=\"".ALTBG1."\" align=\"center\">$table[Type]</td>\n".
					"<td bgcolor=\"".ALTBG2."\" align=\"center\">$table[Rows]</td>\n".
					"<td bgcolor=\"".ALTBG1."\" align=\"center\">$table[Data_length]</td>\n".
					"<td bgcolor=\"".ALTBG2."\" align=\"center\">$table[Index_length]</td>\n".
					"<td bgcolor=\"".ALTBG1."\" align=\"center\">$table[Data_free]</td>\n".
					"</tr>\n";
				$totalsize += $table[Data_length] + $table[Index_length];
			}
			echo "<tr class=\"header\"><td colspan=\"7\" align=\"right\">ռݿ⣺".sizecount($totalsize)."</td></tr></table><tr><td align=\"center\"><br><input type=\"submit\" name=\"optimizesubmit\" value=\"Żݱ\"></td></tr>\n";
		} else {
			$db->unbuffered_query("DELETE FROM $table_subscriptions");
			$query = $db->query("SHOW TABLE STATUS LIKE '$tablepre%'");
			while($table = $db->fetch_array($query)) {
				$tablename = ${$table[Name]};
				if(!$tablename) {
					$tablename = "δŻ";
				} else {
					$tablename = "Ż";
					$db->query("OPTIMIZE TABLE $table[Name]");
				}
				echo "<tr>\n".
					"<td bgcolor=\"".ALTBG1."\" align=\"center\">$tablename</td>\n".
					"<td bgcolor=\"".ALTBG2."\" align=\"center\">$table[Name]</td>\n".
					"<td bgcolor=\"".ALTBG1."\" align=\"center\">$table[Type]</td>\n".
					"<td bgcolor=\"".ALTBG2."\" align=\"center\">$table[Rows]</td>\n".
					"<td bgcolor=\"".ALTBG1."\" align=\"center\">$table[Data_length]</td>\n".
					"<td bgcolor=\"".ALTBG2."\" align=\"center\">$table[Index_length]</td>\n".
					"<td bgcolor=\"".ALTBG1."\" align=\"center\">0</td>\n".
					"</tr>\n";
				$totalsize += $table[Data_length] + $table[Index_length];
			}
			echo "<tr class=\"header\"><td colspan=\"7\" align=\"right\">ռݿ⣺".sizecount($totalsize)."</td></tr></table>";
		}
	}

	echo "</table></form>";
}

?>